#define MUXDEV "/dev/mux"

/* ioctls, only I_STR ioctls are supported */
#define MUX_I_BASE (('m' << 24) | ('u' << 16) | ('x' << 8))

#define MUX_I_GETSTAT	(MUX_I_BASE | 1)	/* get statistics	*/

/* for MUX_I_GETSTAT */
struct mux_statistics {
	size_t		num_msg;	/* number of messages		*/
};

/* 
 * Messages sent to and routed downstream by mux consist of control and 
 * data parts. The control part contains the routing info. The data part
 * has no meaning to mux.
 */

struct mux_ctl {
	int cmd;        /* values: MUX_C_*   			*/
	int error;      /* 0 if ok              		*/
	int down_idx;	/* receiver downstream, I_LINK l_index	*/
	int up_idx;	/* receiver upstream, upper minor num	*/
};

#define MUX_C_ROUTE	'r'
#define MUX_C_STAT	'S'

/* values for mux_ctl->error */
#define MUX_ERR_BAD_L_INDEX	1
