/*
 * Permanently link device underneath sspy device.
 *
 * usage: plink <devive>
 */

#include <sys/types.h>
#include <stropts.h>
#include <sys/conf.h>
#include <errno.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "sspy.h"

void Error(char *str, ...);

int
main(int argc, char **argv)
{
	int sspy_fd, fd, l, i;

	if (argc != 2)
		Error("usage: %s <device>", argv[0]);

	sspy_fd = open(SSPYDEV, O_RDWR);
	if (sspy_fd < 0)
		Error("cannot open %s", SSPYDEV);
		
	fd = open(argv[1], O_RDWR);
	if (fd < 0)
		Error("cannot open %s", argv[1]);

	l = ioctl(sspy_fd, I_PLINK, fd);
	if (l < 0)
		Error("ioctl I_PLINK");
	printf("linked %s, l_index %d\n", argv[1], l);

	if (close(fd) < 0)
		Error("close loop");

	return 0;
}

void
Error(char *str, ...)
{
        va_list ap;
	int e;

	e = errno;

        va_start(ap, str);
        vfprintf(stderr, str, ap);
	va_end(ap);
        fprintf( stderr, "\n" );

	if (e)
		fprintf(stderr, "system error %d: %s\n", e, strerror(e));

        exit(1);
}

